#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>

#include <gtk/gtk.h>
#include <glade/glade.h>

int popup=0, master_retval=0;

// Text Buffer as a global var
GtkTextBuffer *buffer;
// File descriptors for pipe
int fds[2];

GladeXML         *builder;  
GtkWidget		*indicator;
GdkColor color_red, color_green, color_yellow;

//Callback function to watch data in standard output and write to a view text widget
void input_callback (gpointer data, gint source, GdkInputCondition condition)
{
	gchar buf[1024];
	gint chars_read;
	GtkTextIter iter;
	chars_read = 1024;
	gtk_text_buffer_get_end_iter(buffer, &iter);
	while (chars_read == 1024){
		chars_read = read(fds[0], buf, 1024);
		gtk_text_buffer_insert (buffer, &iter, buf, chars_read);
	}
}

GChildWatchFunc jbi_exit(int pID)
{
	master_retval=system("grep \"received, 0% packet loss\" /root/gtk_example_7390/tmpfs/output");

	g_print("\n Return Value: %d\n",master_retval);
	g_print("\n WEXITSTATUS: %d\n", WEXITSTATUS(pID));

	if(master_retval==0)
	{
		gtk_button_set_label (indicator, "STATUS:  PASSED");
		gtk_widget_modify_fg (indicator, GTK_STATE_NORMAL, &color_green);
		gtk_widget_modify_bg (indicator, GTK_STATE_NORMAL, &color_green);
	} else
	{
		gtk_button_set_label (indicator, "STATUS:  FAILED");
		gtk_widget_modify_fg (indicator, GTK_STATE_NORMAL, &color_red);
		gtk_widget_modify_bg (indicator, GTK_STATE_NORMAL, &color_red);
	}

   return 0;

}

void
on_window_destroy (GtkObject *object, gpointer user_data)
{
	gtk_main_quit();
}

void
on_button1_clicked (GtkButton *button, gpointer user_data)
{

	gtk_text_buffer_set_text (buffer, "", -1);
	gdk_flush();

		gtk_button_set_label (indicator, "STATUS:  RUNNING");
		gtk_widget_modify_fg (indicator, GTK_STATE_NORMAL, &color_yellow);
		gtk_widget_modify_bg (indicator, GTK_STATE_NORMAL, &color_yellow);

	pid_t pID = fork();
	g_child_watch_add(pID, (GChildWatchFunc)jbi_exit, popup); // so we can make a callback when the child exits

	if(pID == 0)	//child
	{
		master_retval=system("/root/gtk_example_7390/pingtest");
		
		exit(0);
	}

}

void
on_button3_clicked (GtkButton *button, gpointer user_data)
{
	gtk_main_quit();

}

int main(int argc, char *argv[])
{
    GtkWidget       *window;
    GtkWidget		*view;
   
    gdk_color_parse ("red", &color_red);
    gdk_color_parse ("green", &color_green);
    gdk_color_parse ("yellow", &color_yellow);
    
	// create pipe
	pipe (fds);
	// Redirect fds to write to stdout
	dup2 (fds[1], STDOUT_FILENO);

    gtk_init (&argc, &argv);

	gdk_color_parse ("red", &color_red);
	gdk_color_parse ("green", &color_green);
	gdk_color_parse ("yellow", &color_yellow);

    builder = glade_xml_new("./mainwindow.glade", NULL, NULL);
	view = glade_xml_get_widget(builder, "textview1");
	indicator = glade_xml_get_widget(builder, "button4");

	//indicator.State = Gtk.StateType.Insensitive;
	gtk_widget_modify_fg (indicator, GTK_STATE_NORMAL, &color_green);
	gtk_widget_modify_bg (indicator, GTK_STATE_NORMAL, &color_green);

	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (view));
	gtk_text_buffer_set_text (buffer, "<START>", -1);
	// This is the signal connection to call input_callback when we have data in stdout read end of the pipe
	gdk_input_add (fds[0], GDK_INPUT_READ, input_callback, NULL);

    window = glade_xml_get_widget(builder,"window");
	glade_xml_signal_autoconnect(builder);
    
    gtk_widget_show(window);   
    
    g_object_unref(G_OBJECT (builder));
    gtk_main ();
  
    return 0;
}

